# Supports Organizer.rb
require 'sketchup'

module Matt_Tools
module Toggle_Units
	module_function
	@dir=File.dirname(__FILE__)
	@strings = {}
	if ["fr","FR","fr-FR"].include?(Sketchup.os_language)
		f=IO.readlines(File.join(@dir,"/tustrings.fr"))
	else
		f=IO.readlines(File.join(@dir,"/tustrings.en"))
	end
	n=0
	f.each do |l|
		l=l.strip.split("___")
		@strings[l.first]=l[1]
	end
	
def create_icon
	
end

def go(int)
	model=Sketchup.active_model
	op=model.options[@strings['UnitsOptions']]
	lst={
		0=>@strings['tufe'],
		1=>@strings['tuin'],
		2=>@strings['tumm'],
		3=>@strings['tucm'],
		4=>@strings['tume'],
		5=>@strings['tudec'],
		6=>@strings['tuarc'],
		7=>@strings['tuing'],
		8=>@strings['tufra']
	}
	case int
		when 0,1,2,3,4
			op[@strings['LengthUnit']]=int
			puts "#{@strings['lu']} #{lst[int]}"
		when 5,6,7,8
			result = int - 5
		case result
			when 1;op[@strings['LengthUnit']] = 1
			when 2;op[@strings['LengthUnit']] = 0
			when 3;op[@strings['LengthUnit']] = 1
		end
		op[@strings['LengthFormat']] = result
		puts "#{@strings['lf']} #{lst[int]}"
	end
	model.active_view.invalidate
	return nil
end

def validation_proc(int)
	op=Sketchup.active_model.options[@strings['UnitsOptions']]
	case int
		when 0,1,2,3,4
		if op[@strings['LengthFormat']] != 0
			return MF_GRAYED
		elsif op[@strings['LengthUnit']] == int
			return MF_CHECKED
		else
			return MF_UNCHECKED
		end
		
		when 5,6,7,8
		result = int - 5
		if op[@strings['LengthFormat']] == result
			return MF_CHECKED
		else
			return MF_UNCHECKED
		end
	end
end

def Length_Precision(int)
	op=Sketchup.active_model.options[@strings['UnitsOptions']]
	return if not [1,-1].index(int)
	lp = op[@strings['LengthPrecision']]
	if 0 <= (lp + int) && (lp + int) <= 10
		op[@strings['LengthPrecision']] = lp + int
		puts "#{@strings['dp']} #{lp+int}"
	end
	Sketchup.active_model.active_view.invalidate
end

def display_unit_format
	model=Sketchup.active_model
	op=model.options[@strings['UnitsOptions']]
	if op[@strings['SuppressUnitsDisplay']] == true
		op[@strings['SuppressUnitsDisplay']]= false
		puts @strings['df']
	else
		op[@strings['SuppressUnitsDisplay']]= true
		puts @strings['hf']
	end
	model.active_view.invalidate
end

def display_unit_format_validation_proc
	op=Sketchup.active_model.options[@strings['UnitsOptions']]
	if [1,2].include? op[@strings['LengthFormat']]
		return MF_GRAYED
	elsif op[@strings['SuppressUnitsDisplay']] == true
		return MF_UNCHECKED
	else
		return MF_CHECKED
	end
end

def toolbar_manager
	puts 'Matt_Tools::Toggle_Units.toolbar_manager'
	#Getting settings
	#settings.txt in a file which contains all states of the checkboxes in the html file
	@dir=File.dirname(__FILE__)
	settings=IO.readlines(File.join(@dir,'/settings.txt'))
	settings.each{|l|l.strip!}
	
	#To compare initial and future settings
	initial_settings=settings.dup
	
	#Create webdialog
	dial=UI::WebDialog.new(@strings['tm'], false, @strings['tm'], 320, 580, 150, 100, false)
	dial.set_file(File.join(@dir, "toolbar_manager.html"))
	
	#Here is the problem. I try to set all checkboxes with setting file. Each line correspond to a checkbox. 
	n=0
	if RUBY_PLATFORM.include?('darwin')
		dial.show_modal{
			for e in settings
				str="rubyCheck('c#{n}','#{e}')"
				dial.execute_script(str)
				n+=1
			end
		}
	else
		dial.show{
			for e in settings
				str="rubyCheck('c#{n}','#{e}')"
				dial.execute_script(str)
				n+=1
			end
		}
	end
	
	dial.add_action_callback("cback") {|dialog, params|
		case params
		#close webdialog when you click on "Cancel"
		when "stop"
			dial.close
		#Set settings file with the new settings when you click on "Ok"
		when "go"
			if settings!=initial_settings
				f=File.open(File.join(@dir,'/settings.txt'),"w")
				for e in settings
					f.puts e
				end
				f.close
				UI.messagebox(@strings['atc'])
			else
				UI.messagebox(@strings['ntc'])
				
			end
			dial.close
		#When a checkbox is checked or unchecked
		when "0","1","2","3","4","5","6","7","8","9","10","11","12","13"
			n=params.to_i
			#reverse state od the checkbox in settings file
			if settings[n]=="true"
				settings[n]="false"
			else
				settings[n]="true"
			end
		end
	}
end

unless file_loaded?(__FILE__)
	file_loaded(__FILE__)

	$submenu ? (organizer = $submenu) : (organizer = UI.menu("Plugins"))
	menu = organizer.add_submenu(@strings['tu'])
		menu.add_item(@strings['tudec']) { go(5) }
		menu.add_item(@strings['tuarc']) { go(6) }
		menu.add_item(@strings['tufra']) { go(7) }
		menu.add_item(@strings['tuing']) { go(8) }
		menu.add_separator
		menu.add_item(@strings['tuin']) { go(1) }
		menu.add_item(@strings['tufe']) { go(0) }
		menu.add_item(@strings['tumm']) { go(2) }
		menu.add_item(@strings['tucm']) { go(3) }
		menu.add_item(@strings['tume']) { go(4) }
		menu.add_separator
		menu.add_item(@strings['ddp']) { Length_Precision(-1) }
		menu.add_item(@strings['idp']) { Length_Precision(1) }
		menu.add_item(@strings['df']) {	display_unit_format }
		menu.add_separator
		menu.add_item(@strings['tm']) {	toolbar_manager }

	settings=IO.readlines(File.join(@dir,'/settings.txt'))
	settings.each{|l|l.strip!}

	return if not settings.include?("true")

	tb = UI::Toolbar.new(@strings['tu'])
	n=0
	while n < settings.length
		if settings[n]=="true"
			case n
				when 0
				cmd = UI::Command.new(@strings['tudec']) { go(5) }					
				cmd.small_icon = File.join(@dir, "tudec_16.png")
				cmd.large_icon = File.join(@dir, "tudec_24.png")
				cmd.tooltip = cmd.status_bar_text = "#{@strings['tudu']} #{@strings['tudec']}"
				cmd.set_validation_proc { validation_proc(5) }
				tb.add_item cmd
			
				when 1
				cmd = UI::Command.new(@strings['tuarc']) { go(6) }
				cmd.small_icon = File.join(@dir, ("tuarc_16.png"))
				cmd.large_icon = File.join(@dir, ("tuarc_24.png"))
				cmd.tooltip = cmd.status_bar_text = "#{@strings['tudu']} #{@strings['tuarc']}"
				cmd.set_validation_proc { validation_proc(6) }
				tb.add_item cmd
			
				when 2
				cmd = UI::Command.new(@strings['tufra']) { go(8) }
				cmd.small_icon = File.join(@dir, ("tufra_16.png"))
				cmd.large_icon = File.join(@dir, ("tufra_24.png"))
				cmd.tooltip = cmd.status_bar_text = "#{@strings['tudu']} #{@strings['tufra']}"
				cmd.set_validation_proc { validation_proc(8) }
				tb.add_item cmd
			
				when 3
				cmd = UI::Command.new(@strings['tuing']) { go(7) }
				cmd.small_icon = File.join(@dir, ("tuing_16.png"))
				cmd.large_icon = File.join(@dir, ("tuing_24.png"))
				cmd.tooltip = cmd.status_bar_text = "#{@strings['tudu']} #{@strings['tuing']}"
				cmd.set_validation_proc { validation_proc(7) }
				tb.add_item cmd
			
				when 4
				tb.add_separator
			
				when 5
				cmd = UI::Command.new(@strings['tuin']) { go(0) }
				cmd.small_icon = File.join(@dir, ("tuin_16.png"))
				cmd.large_icon = File.join(@dir, ("tuin_24.png"))
				cmd.tooltip = cmd.status_bar_text = "#{@strings['tudu']} #{@strings['tuin']}"
				cmd.set_validation_proc { validation_proc(0) }
				tb.add_item cmd
			
				when 6
				cmd = UI::Command.new(@strings['tufe']) { go(1) }
				cmd.small_icon = File.join(@dir, ("tufe_16.png"))
				cmd.large_icon = File.join(@dir, ("tufe_24.png"))
				cmd.tooltip = cmd.status_bar_text = "#{@strings['tudu']} #{@strings['tufe']}"
				cmd.set_validation_proc { validation_proc(1) }
				tb.add_item cmd
			
				when 7
				cmd = UI::Command.new(@strings['tumm']) { go(2) }
				cmd.small_icon = File.join(@dir, ("tumm_16.png"))
				cmd.large_icon = File.join(@dir, ("tumm_24.png"))
				cmd.tooltip = cmd.status_bar_text = "#{@strings['tudu']} #{@strings['tumm']}"
				cmd.set_validation_proc { validation_proc(2) }
				tb.add_item cmd
			
				when 8
				cmd = UI::Command.new(@strings['tucm']) { go(3) }
				cmd.small_icon = File.join(@dir, ("tucm_16.png"))
				cmd.large_icon = File.join(@dir, ("tucm_24.png"))
				cmd.tooltip = cmd.status_bar_text = "#{@strings['tudu']} #{@strings['tucm']}"
				cmd.set_validation_proc { validation_proc(3) }
				tb.add_item cmd
			
				when 9
				cmd = UI::Command.new(@strings['tume']) { go(4) }
				cmd.small_icon = File.join(@dir, ("tume_16.png"))
				cmd.large_icon = File.join(@dir, ("tume_24.png"))
				cmd.tooltip = cmd.status_bar_text = "#{@strings['tudu']} #{@strings['tume']}"
				cmd.set_validation_proc { validation_proc(4) }
				tb.add_item cmd
			
				when 10
				tb.add_separator
			
				when 11
				cmd = UI::Command.new(@strings['ddp']) { Length_Precision(-1) }
				cmd.small_icon = File.join(@dir, ("tumoins_16.png"))
				cmd.large_icon = File.join(@dir, ("tumoins_24.png"))
				cmd.tooltip = cmd.status_bar_text = @strings['ddp']
				tb.add_item cmd
			
				when 12
				cmd = UI::Command.new(@strings['idp']) { Length_Precision(1) }
				cmd.small_icon = File.join(@dir, ("tuplus_16.png"))
				cmd.large_icon = File.join(@dir, ("tuplus_24.png"))
				cmd.tooltip = cmd.status_bar_text = @strings['idp']
				tb.add_item cmd
			
				when 13
				cmd = UI::Command.new(@strings['df']) { display_unit_format }
				cmd.small_icon = File.join(@dir, ("tuduf_16.png"))
				cmd.large_icon = File.join(@dir, ("tuduf_24.png"))
				cmd.tooltip = cmd.status_bar_text = @strings['df']
				cmd.set_validation_proc { display_unit_format_validation_proc }
				tb.add_item cmd
			end
		end
		n+=1
	end
	state = tb.get_last_state
	if state==TB_NEVER_SHOWN
		tb.show 
	elsif state==TB_VISIBLE
		tb.restore
	end
end

end #Toggle_Units
end #Matt_Tools